/*******************************************************************************
 *                                                                             *
 *   Author: Victor Mateevitsi (mvictoras@gmail.com)                           *
 *                                                                             *
 *   This file is part of CS 491 Project1.                                     *
 *                                                                             * 
 *   CS 491 Project1 is free software: you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by      *
 *   the Free Software Foundation, either version 3 of the License, or         *
 *   (at your option) any later version.                                       *
 *                                                                             *
 *   CS 491 Project1 is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *   GNU General Public License for more details.                              *
 *                                                                             *
 *   You should have received a copy of the GNU General Public License         *
 *   along with CS 491 Project1.  If not, see <http://www.gnu.org/licenses/>.  *
 *                                                                             *
 *******************************************************************************/

/********************************************************************************
 *                                class BarChart                                *
 *                              Chart - > BarChart                              *
 * BarChart class is a generic class for creating bar charts.                   *
 *                                                                              *
 ********************************************************************************/

class BarChart extends Chart {

  /********************************************************************************
   *                                                                              *
   *                               Constructors                                   *
   *                                                                              *
   ********************************************************************************/
  
  BarChart(int chartWidth, int chartHeight, String labelX, String labelY, String title, float[] xValues, float[] yValues) {
    super(chartWidth, chartHeight, labelX, labelY, title, xValues, yValues);
  }
  
  BarChart(int chartWidth, int chartHeight, String labelX, String labelY, String title, String[] xValues, float[] yValues) {
    super(chartWidth, chartHeight, labelX, labelY, title, xValues, yValues);
  }
  
  BarChart(int chartWidth, int chartHeight, String labelX, String labelY, String title, float[] xValues) {
    super(chartWidth, chartHeight, labelX, labelY, title, xValues);
  }
  
  
 /********************************************************************************
  *                                                                              * 
  *                               Functions                                      *
  *                                                                              *
  ********************************************************************************/
   
  /*
   * function: drawYAxis()
   * 
   * Overridden function.
   * Draws the Y axis of the Chart with the appropiate labels
   */
  String[] yStringValues;
  public void drawYAxis() {
    stroke(dataStrokeColor);
    fill(fontColor);
    strokeWeight(1);
    textSize(8);
    textAlign(RIGHT, CENTER);
    
    line(0, 0, 0, chartHeight);
    
    for( int i = 0; i < xValues.length; i++ ) {
      float yCoord = map(i + 1, 0, 6, chartHeight, 0);
      
      line(0, yCoord, -5, yCoord);
      text(yStringValues[i], -10, yCoord);
      
    }
  }
  
  public void setYAxisLabels(String[] yStringValues)
  {
    this.yStringValues = yStringValues;
  }
}

