/*******************************************************************************
 *                                                                             *
 *   Author: Xinjiang Shao (shaoxinjiang @gmail.com)                           *
 *                                                                             *
 *   This file is part of CS 424 Project1.                                     * 
 *                                                                             *
 *******************************************************************************/
//import org.gicentre.utils.stat.*;
import controlP5.*;

public RoomMap room_map;
public TimeLineChart chart1,chart2,chart3,chart4,chart5,chart6,chart7;
int[] toggleLineChart;
float plotX1,plotX2,plotY1,plotY2;
String startDate,endDate;
HorizontalBarChart yearlyBarChart1,yearlyBarChart2,yearlyBarChart3,yearlyBarChart4,yearlyBarChart5,yearlyBarChart6,yearlyBarChart7;
int[] toggleYear;
// GUI
ControlP5 controlP5;
Button ClassRoomBtn, PrototypeSpaceBtn, LougueBtn, MachineRoomBtn, OfficeSpaceBtn, MeetingRoomBtn, MainLabBtn;
Button ZoomInBtn,ZoomOutBtn,YearlyBtn,MonthlyBtn,WeeklyBtn,DailyBtn,HourlyBtn,OutdoorDataBtn;
// data
DataSet DataOne,DataTwo,DataThree,DataFour,DataFive,DataSix,DataSeven;
void setup()
{
  size(DEFAULT_WINDOW_WIDTH, DEFAULT_WINDOW_HEIGHT);
  controlP5 = new ControlP5(this);
  room_map = new RoomMap(controlP5);
  
  setupToolline();
  frameRate(30); 
  setupFileData();
  setupTimelineController();
  setupBarChart();
  setupCharts();
  toggleLineChart = new int[8];
  toggleLineChart[1] = 1;
  for (int i = 2; i< 8; i++)
    toggleLineChart[i] = 0;
  toggleYear = new int[8];
  for (int i = 1; i< 8; i++)
    toggleYear[i] = 0; 
  smooth();
}


void draw()
{
  background(COLOR_BLACK);
  pushMatrix();
    room_map.drawMap();
  popMatrix();
  
  drawChartAreaBackground();
  
  if (toggleLineChart[1]%2 == 1)
  { 
    drawChart1();
  }
  if (toggleLineChart[2]%2 == 1)
  { 
    drawChart2();
  }
   if (toggleLineChart[1]%2 == 1)
  { 
    drawChart1();
  }
  if (toggleLineChart[3]%2 == 1)
  { 
    drawChart3();
  }
   if (toggleLineChart[4]%2 == 1)
  { 
    drawChart4();
  }
  if (toggleLineChart[5]%2 == 1)
  { 
    drawChart5();
  }
   if (toggleLineChart[6]%2 == 1)
  { 
    drawChart6();
  }
  if (toggleLineChart[7]%2 == 1)
  { 
    drawChart7();
  }
  
  for(int i =1; i<8; i++)
  {
    if (toggleYear[i]%2 == 1)
    { 
      drawBarChart(i);
    }
  }
  drawTimelineController();
  // select room and show it
  //loop();
}
void mouseDragged() 
{
    if (dist(plotX1, plotY1, mouseX, mouseY) < 10)
      plotX1 = mouseX; 
    
    if (dist(plotX2, plotY2, mouseX, mouseY) < 10)
      plotX2 = mouseX;
      
    if (dist((plotX1+plotX2)/2, (plotY1+plotY2)/2, mouseX, mouseY) < 10 )
    {
      if (dist(plotX1, plotY1, mouseX, mouseY) > dist(plotX2, plotY2, mouseX, mouseY))
      {
        plotX1 = plotX1 + 2;
        plotX2 = plotX2 + 2;
      }
      else
      {
        plotX1 = plotX1 - 2;
        plotX2 = plotX2 - 2;
      }
    }
    
 // startDate = PosToDate(plotX1);
 // endDate = PosToDate(plotX2);
}

void setupFileData()
{
  DataOne = new DataSet();
  DataOne.readDataFromFile(ROOMONE);
  DataTwo = new DataSet();
  DataTwo.readDataFromFile(ROOMTWO);
  DataThree = new DataSet();
  DataThree.readDataFromFile(ROOMTHREE);
  DataFour = new DataSet();
  DataFour.readDataFromFile(ROOMFOUR);
  DataFive = new DataSet();
  DataFive.readDataFromFile(ROOMFIVE);
  DataSix = new DataSet();
  DataSix.readDataFromFile(ROOMSIX);
  DataSeven = new DataSet();
  DataSeven.readDataFromFile(ROOMSEVEN);
}
public void controlEvent(ControlEvent theEvent)
{
  println(theEvent.controller().name());
}

// Deal with events 
public void Yearly(int theValue)
{
  println("a button event from Yearly: "+theValue);
  if(toggleLineChart[1]%2 == 1)
     toggleYear[1]++;
  if(toggleLineChart[2]%2 == 1)
     toggleYear[2]++;
  if(toggleLineChart[3]%2 == 1)
     toggleYear[3]++;
  if(toggleLineChart[4]%2 == 1)
     toggleYear[4]++;
  if(toggleLineChart[5]%2 == 1)
     toggleYear[5]++; 
  if(toggleLineChart[6]%2 == 1)
     toggleYear[6]++; 
  if(toggleLineChart[7]%2 == 1)
     toggleYear[7]++;
}
public void Class_Room(int theValue)
{
  println("a button event from ClassRoom: "+theValue);
  toggleLineChart[6]++;
}
public void Proto_Space(int theValue)
{
  println("a button event from Proto_Space: "+theValue);
  toggleLineChart[5]++;
}
public void Lougue(int theValue)
{
  println("a button event from Lougue: "+theValue);
  toggleLineChart[4]++;
}
public void Machine_Room(int theValue)
{
  println("a button event from Machine_Room: "+theValue);
  toggleLineChart[3]++;
}
public void Office_Space(int theValue)
{
  println("a button event from Office_Space: "+theValue);
  toggleLineChart[7]++;
}
public void Meeting_Room(int theValue)
{
  println("a button event from Meeting_Room: "+theValue);
  toggleLineChart[1]++;
}
public void Main_Lab(int theValue)
{
  println("a button event from Main_Lab: "+theValue);
  toggleLineChart[2]++;
}
