/*******************************************************************************
 *                                                                             *
 *   Author: Victor Mateevitsi (mvictoras@gmail.com)                           *
 *                                                                             *
 *   This file is part of CS 491 Project1.                                     *
 *                                                                             * 
 *   CS 491 Project1 is free software: you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by      *
 *   the Free Software Foundation, either version 3 of the License, or         *
 *   (at your option) any later version.                                       *
 *                                                                             *
 *   CS 491 Project1 is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *   GNU General Public License for more details.                              *
 *                                                                             *
 *   You should have received a copy of the GNU General Public License         *
 *   along with CS 491 Project1.  If not, see <http://www.gnu.org/licenses/>.  *
 *                                                                             *
 *******************************************************************************/

/********************************************************************************
 *                               class LineChart                                *
 *                             Chart - > LineChart                              *
 * LineChart class is class for creating line charts.                           *
 *                                                                              *
 ********************************************************************************/
 
class LineChart extends Chart {
  
 /********************************************************************************
  *                                                                              *
  *                               Constructors                                   *
  *                                                                              *
  ********************************************************************************/
  LineChart(int chartWidth, int chartHeight, String labelX, String labelY, String title, float[] xValues, float[] yValues) {
    super(chartWidth, chartHeight, labelX, labelY, title, xValues, yValues);
  }
  
  LineChart(int chartWidth, int chartHeight, String labelX, String labelY, String title, String[] xValues, float[] yValues) {
    super(chartWidth, chartHeight, labelX, labelY, title, xValues, yValues);
  }
  
 /********************************************************************************
  *                                                                              * 
  *                               Functions                                      *
  *                                                                              *
  ********************************************************************************/
  
 /*
  * function: drawData()
  * 
  * Overridden function.
  * Draws the actual data of the plotted chart.
  */
  void drawData() {
    for(int i = 0; i < xValues.length; i++) {  
      float xCoord = map(xValues[i], xMinValue, xMaxValue, 0, chartWidth);
      float yCoord = map(yValues[i], yMinValue, yMaxValue, chartHeight, 0);
      stroke(dataStrokeColor);
      //fill(0);
      strokeWeight(dataStrokeWeight);
      point(xCoord, yCoord);
    }
  }
  
}

