/*******************************************************************************
 *                                                                             *
 *   Author: Xinjiang Shao (shaoxinjiang @gmail.com)                           *
 *                                                                             *
 *   This file is part of CS 424 Project1.                                     * 
 *                                                                             *
 *******************************************************************************/
// Room Map 
import controlP5.*;
class RoomMap
{

  private float startingX;
  private float startingY;
  private float endingX;
  private float endingY;
  private PImage roomMap;

  RoomMap(ControlP5 ui)
  {
    
    this.startingX = this.startingY = 0;
    this.endingX = ROOM_MAP_WIDTH;
    this.endingY = ROOM_MAP_HEIGHT;
    roomMap = loadImage(ROOM_MAP_PATH);
    setupButtons(ui);
  }
 
  public void drawMap()
  {
    translate(0, 0);
    fill(COLOR_WHITE);
    scale(ROOM_MAP_SCALE_RATIO);
    stroke(0);
    image(roomMap, startingX, startingY, endingX, endingY);
    smooth();
  }
  
  void setupButtons(ControlP5 controlP5)
  {
    pushMatrix();
    translate(DEFAULT_LEFT_BOX_WIDTH, DEFAULT_LEFT_BOX_HEIGHT);
    ClassRoomBtn      = controlP5.addButton("Class_Room",      6, 50, 70, 75, 120);
    PrototypeSpaceBtn = controlP5.addButton("Proto_Space",     5, 50, 210, 75, 55);
    LougueBtn         = controlP5.addButton("Lougue",          4, 50, 280, 75, 60);
    MachineRoomBtn    = controlP5.addButton("Machine_Room",    3, 50, 360, 65, 120);
    OfficeSpaceBtn    = controlP5.addButton("Office_Space",    7, 170, 70, 70, 120);
    MeetingRoomBtn    = controlP5.addButton("Meeting_Room",    1, 170, 210, 70, 130);
    MainLabBtn        = controlP5.addButton("Main_Lab",        2, 130, 360, 100, 120);
    // Setup background color
    ClassRoomBtn.setColorBackground(COLOR_LIGHT_PURPLE);
    PrototypeSpaceBtn.setColorBackground(COLOR_BLUE);
    LougueBtn.setColorBackground(COLOR_RED);
    MachineRoomBtn.setColorBackground(COLOR_DARK_GREEN);
    OfficeSpaceBtn.setColorBackground(COLOR_LIGHT_YELLOW);
    MeetingRoomBtn.setColorBackground(COLOR_DARK_YELLOW);
    MainLabBtn.setColorBackground(COLOR_PINK);
    popMatrix();
  }

}

