/*******************************************************************************
 *                                                                             *
 *   Author: Xinjiang Shao (shaoxinjiang @gmail.com)                           *
 *                                                                             *
 *   This file is part of CS 424 Project1.                                     * 
 *                                                                             *
 *******************************************************************************/
void setupToolline()
{
  pushMatrix();
    ZoomInBtn      = controlP5.addButton("ZoomIn",      101, 10, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    ZoomOutBtn     = controlP5.addButton("ZoomOut",     102, 70, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    YearlyBtn      = controlP5.addButton("Yearly",      103, 130, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    MonthlyBtn     = controlP5.addButton("Monthly",     104, 180, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    WeeklyBtn      = controlP5.addButton("Weekly",      105, 230, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    DailyBtn       = controlP5.addButton("Daily",       106, 280, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    HourlyBtn      = controlP5.addButton("Hourly",      107, 330, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 50, 50);
    OutdoorDataBtn = controlP5.addButton("OutdoorData", 108, 390, DEFAULT_BOTTOM_BOX_HEIGHT+int(DEFAULT_LEFT_BOX_HEIGHT), 60, 50);
  pushMatrix();
}

void setupTimelineController()
{
  pushMatrix();
  // get data
  plotX1 = 15;
  plotX2 = 70;
  plotY1 = 30 + DEFAULT_LEFT_BOX_HEIGHT;
  plotY2 = 40 + DEFAULT_LEFT_BOX_HEIGHT;
  PosToDate(plotX1);
  PosToDate(plotX2);
  popMatrix();
}

void drawTimelineController()
{
  pushMatrix();
    translate(0, DEFAULT_LEFT_BOX_HEIGHT);
    fill(COLOR_WHITE);
    rectMode(CORNERS);
    noStroke();
    rect(0, 0, DEFAULT_BOTTOM_BOX_WIDTH, DEFAULT_BOTTOM_BOX_HEIGHT);
    fill(COLOR_GREY);
    rectMode(CORNERS);
    rect(15, 15, DEFAULT_BOTTOM_BOX_WIDTH-15, DEFAULT_BOTTOM_BOX_HEIGHT-15);
    strokeWeight(1);
    stroke(COLOR_BLACK);
    for(int i = 0; i < 2217; i++)
    {
      switch(i)
      {
        case 0:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2005", x+10, 5);
          break;
        }
        case 155:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2006", x+10, 5);
          break;
        }
        case 520:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2007", x+10, 5);
          break;
        }
        case 885:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2008", x+10, 5);
          break;
        }
        case 1251:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2009", x+10, 5);
          break;
        }
        case 1616:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2010", x+10, 5);
          break;
        }
        case 1982:
        {
          float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
          stroke(COLOR_RED);
          strokeWeight(3);
          line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
          text("2011", x+10, 5);
          break;
        }
      }
      if (i % 100 == 0 && i != 0 && i != 520 && i!= 155 && i!= 885 && i!= 1251 && i!= 1616 && i!=1982)
      { 
        float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
        stroke(COLOR_BLACK);
        strokeWeight(1);
        line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-25);
      }
      if (i % 25 == 0 && i != 0 && i != 520 && i!= 155 && i!= 885 && i!= 1251 && i!= 1616 && i!=1982)
      {
        float x = map(i, 0, 2217, 5, DEFAULT_BOTTOM_BOX_WIDTH-30);
        stroke(COLOR_BLACK);
        strokeWeight(1);
        line(x+10, 15, x+10, DEFAULT_BOTTOM_BOX_HEIGHT-30);
      }
    }
  popMatrix();
  
  drawFlagBar();
}

void drawFlagBar()
{
  pushMatrix();
    fill(COLOR_BLACK);
    rectMode(CORNERS);
    noStroke();
    rect(plotX1, plotY1, plotX2, plotY2);
  popMatrix();
}

